Jump to: navigation, search

Difference between revisions of "EclipseLink/Dependencies"

 
(64 intermediate revisions by 10 users not shown)
Line 1: Line 1:
 
The following is a list of Dependencies that EclipseLink requires to compile all components.   
 
The following is a list of Dependencies that EclipseLink requires to compile all components.   
 +
__TOC__
 +
 +
== Build Tools, Dependencies ==
  
 
{|{{BMTableStyle}}
 
{|{{BMTableStyle}}
Line 5: Line 8:
 
! Library Name
 
! Library Name
 
! Version
 
! Version
! Files
 
! License
 
 
! IP Bug
 
! IP Bug
 +
! Dist/Comp/Test
 
! Notes
 
! Notes
 
|-
 
|-
| [http://asm.objectweb.org/ ASM] || 1.5.3 + ojc patch || none || [http://asm.objectweb.org/license.html License] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1605 RESOLVED-1605] || Internalized into org.eclipse.persistence.internal.libraries.asm.  Used for byte-code weaving of persistent classes
+
| ANT || 1.7.0 / 1.8.4 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=2282 APPROVED-2282] <br> [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=???? MISSING-????] || Compile || Used for compilation.
 
|-
 
|-
| [http://www.antlr.org/ ANTLR] || 3.0 || none || [http://www.antlr.org/license.html License]|| [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1695 1695] <br> [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1359 RESOLVED-1359] || Internalized into org.eclipse.persistence.internal.libraries.antlr. <br> Required for parsing JPQL.
+
| GRADLE || 2.3 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9614 PENDING-9614] || Compile || Used for compilation.
 +
|}
 +
 
 +
== Dependencies ==
 +
 
 +
{|{{BMTableStyle}}
 +
|-{{BMTHStyle}}
 +
! Library Name
 +
! Version
 +
! IP Bug
 +
! Dist/Comp/Test
 +
! Notes
 
|-
 
|-
| JTA || 1.1 || jta.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1613 1613] || Only required when using JTA. Generally provided by host container.
+
| [http://asm.objectweb.org/ ASM] || 6.0.0.ALPHA || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=12786 APPROVED-12786] || Distributed || Internalized into org.eclipse.persistence.internal.libraries.asm. Used for byte-code weaving of persistent classes
 
|-
 
|-
| JMS || 1.1 || jms.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1614 1614] || Only required when using JMS cache coordination. Typically provided by host container.
+
| [http://www.antlr.org/ ANTLR] || 3.2 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=4466 APPROVED-4466] || Distributed || Internalized into org.eclipse.persistence.internal.libraries.antlr. <br> Required for parsing JPQL.
 
|-
 
|-
| JPA (EJB 3.0)|| 1.0 || persistence.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1616 1616] || Only required when using JPA. Required in JavaSE but always included in JavaEE5 containers..
+
| [https://jaxb.java.net JAXB API] || 2.2 / 2.2.12 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8374 APPROVED-8374] || Distributed || Only required when using JAXB (Not required for native OXM usage). Always included in Java EE containers, and in JDK.
 
|-
 
|-
| [http://java.sun.com/j2ee/connector/download.html JavaEE Connector Architecture (JCA)] || 1.5 || connector.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0 ] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1621 1621] || Only required when using EIS data source support through JCA.
+
| [https://jaxb.java.net JAXB Core] || 2.2.11 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8984 APPROVED-8984]|| Distributed || Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in Java EE containers.
 
|-
 
|-
| [https://jaxb.dev.java.net JAXB API] || [https://jaxb.dev.java.net/2.0.5/ 2.0.5] || jaxb-api.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1617 APPROVED-1617] || Only required when using JAXB 2.0 (Not required for native OXM usage). Always included in JavaEE5 containers.
+
| [https://jaxb.java.net JAXB XJC] || 2.2.11 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8371 APPROVED-8371]|| Distributed || Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in JavaEE5 containers.
 
|-
 
|-
| [https://jaxb.dev.java.net JAXB XJC] || [https://jaxb.dev.java.net/2.0.5/ 2.0.5] || jaxb-xjc.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1787 1787]|| Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in JavaEE5 containers.
+
| [http://java.sun.com/products/javamail/downloads/index.html JavaMail] || 1.4 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1619 APPROVED-1619] || Distributed || Required for Web Service attachment handling in MOXy.<br> Always included in Java EE containers.
 
|-
 
|-
| [https://jaxb.dev.java.net JAXB RI] || [https://jaxb.dev.java.net/2.0.5/ 2.0.5] || jaxb-impl.jar  || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1788 1788]|| Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in JavaEE5 containers.
+
| [http://www.osoa.org/download/attachments/36/Java-SDO-Spec-v2.1.0-FINAL.pdf?version=1 Service Data Objects (SDO)] || 2.1.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=2884 APPROVED-2884] || Distributed || Only required when using SDO functionality.
 
|-
 
|-
| StAX <br>(Included in JAXB 2.0) || 1.0 || jsr173_1.0_api.jar  || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1618 APPROVED-1618] || Optional processing style in MOXy. <br>Always included in JavaEE5 containers.
+
| [http://jsonp.java.net/ JSON-P API+RI] || 1.0.4 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8679 APPROVED-8679] || Distributed || Required by JSON support in MOXy, used for JSON parsing.
 
|-
 
|-
| Java Activation Framework <br>(Included in JAXB 2.0) || 1.1 || activation.jar || [http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1620 APPROVED-1620] || Required for Web Service attachment handling in MOXy.<br> Always included in JavaEE5 containers.<br> Available from [http://download.eclipse.org/tools/orbit/downloads/drops/R200709171314/bundles/javax.activation_1.1.0.v200706111329.jar Orbit]
+
| Bean Validation API (javax.validation) || 1.1.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8334 APPROVED-8334] || Distributed || Required by MOXy - used for supporting Bean Validation feature. Reflectively also used in JPA.
 
|-
 
|-
| [http://java.sun.com/products/javamail/downloads/index.html JavaMail] || 1.4 || mail.jar ||[http://www.sun.com/cddl/cddl.html CDDL 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1619 1619] <br> [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1311 RESOLVED-1311] || Required for Web Service attachment handling in MOXy.<br> Always included in JavaEE5 containers. <br> Available from [http://download.eclipse.org/tools/orbit/downloads/drops/R200706192011/bundles/javax.mail_1.4.0.v200706111329.jar Orbit]
+
| JSON-B API || ANY || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9615 PENDING-9615] || Distributed || Required by JSON-B Implementation.
 
|-
 
|-
| [http://www.osoa.org/download/attachments/36/Java-SDO-Spec-v2.1.0-FINAL.pdf?version=1 Service Data Objects (SDO)] || 2.1 || commonj-sdo.jar || [http://www.osoa.org/download/attachments/36/Java-SDO-Spec-v2.1.0-FINAL.pdf?version=1 Custom License] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1622 1622] || Only required when using SDO functionality.
+
| JTA || 1.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1613 APPROVED-1613] || Compile || Only required when using JTA. Generally provided by host container.
 
|-
 
|-
| [http://sourceforge.net/projects/wsdl4j WSDL4J] || 1.6.2 || wsdl4j.jar || [http://wsdl4j.cvs.sourceforge.net/*checkout*/wsdl4j/wsdl4j/license.html?revision=1.2 Common Public License 1.0] || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1701 1701] || Required by DBWS
+
| JMS || 1.1 !!! (pulling org.eclipse.net4j.jms.api:jar:3.1.100.v20140218-1709 from somewhere) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1614 APPROVED-1614] || Compile || Only required when using JMS cache coordination. Typically provided by host container.
 
|-
 
|-
 +
| EJB API || 3.1.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=6329 APPROVED-6329] || Compile || Only required for compilation of MessageDrivenBean code. Included in Java EE containers.
 +
|-
 +
| CDI API || 1.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=6951 APPROVED-6951] || Compile || Included in Java EE containers.
 +
|-
 +
| [http://java.sun.com/j2ee/connector/download.html JavaEE Connector Architecture (JCA)] || 1.6 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=7339 APPROVED-7339] || Compile || Only required when using EIS data source support through JCA.
 +
|-
 +
| JGroups || 3.2.8 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=7143 APPROVED-7143] || Compile || Only required when using JGroups integration available within org.eclipse.persistence.extensions module. Since 2.6
 +
|-
 +
| [https://jaxb.java.net JAXB Impl] || 2.2.11 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8372 APPROVED-8372]|| Test || Only used for RI compatibility testing. Always included in JavaEE5 containers.
 +
|-
 +
| Expression Language API || 2.2 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8429 APPROVED-8429] || Test || Required by Hibernate for Bean Validation testing.
 +
|-
 +
| Expression Language Implementation || 2.2.2 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8430 APPROVED-8430] || Test || Required by Hibernate for Bean Validation testing.
 +
|-
 +
| Classmate library || 1.0.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8433 APPROVED-8433] || Test || Required by Hibernate for Bean Validation testing.
 +
|-
 +
| JBoss Logging Framework || 3.1.4 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8431 APPROVED-8431] || Test || Required by Hibernate for Bean Validation testing.
 +
|-
 +
| Hibernate Bean Validation Implementation || all (5.1.0 current) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=3571 APPROVED-3571] || Test || Required by Hibernate for Bean Validation testing.
 +
|-
 +
| JMockit || 1.10 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8545 APROVED-8545] || Test || Used for mocking objects.
 +
|-
 +
| Kryo || 2.2.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=7299 APROVED-7299] || Test || Used for fast serialization of objects in JPA. Only loaded by reflection when present and enabled. No compilation or runtime dependency.
 +
|-
 +
| JMH Core || 0.9.3 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8546 APROVED-8546] || Test || Required by JMH framework for performance testing.
 +
|-
 +
| JMH Generator || 0.9.3 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8547 APROVED-8547] || Test || Required by JMH framework for performance testing.
 +
|-
 +
| Math Commons || 3.3 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8548 APROVED-8548] || Test || Required by JMH framework for performance testing.
 +
|-
 +
| JOpt Simple || 4.6 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=8549 APROVED-8549] || Test || Required by JMH framework for performance testing.
 +
|-
 +
| OSGi Core || 6.0.0 || [http://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Pax exam || all (4.5.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Pax exam container native || all (4.5.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Pax exam junit4 || all (4.5.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Pax url aether || all (2.4.1) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Pax exam link mvn || all (4.5.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| Apache Felix || all (5.0.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| javax.el || all (3.0.0) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
| log4j || all (2.3) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9814 APROVED-9814] || Test || OSGi testing dependency.
 +
|-
 +
|}
 +
 +
== DBWS Component Specific Dependencies  ==
 +
{|{{BMTableStyle}}
 +
|-{{BMTHStyle}}
 +
! Library Name
 +
! Version
 +
! IP Bug
 +
! Dist/Comp/Test
 +
! Notes
 +
|-
 +
| [http://sourceforge.net/projects/wsdl4j WSDL4J] || 1.6.2 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1701 APPROVED-1701] || Distributed || Required by DBWS
 +
|-
 +
| Servlet API || 2.4.0 / !!! (pulling 3.0.0 somewhere for some reason) || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=2505 APPROVED-2505] <br> [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=???? MISSING-????] || Compile || Required by DBWS
 +
|-
 +
| [https://jax-rs-spec.java.net/ JAX-RS API] || 2.0.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9752 APPROVED-9752] || Compile || Used for compilation of JPA-RS features.
 +
|-
 +
| [https://jersey.java.net/ Jersey Client] || 2.14 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=9805 APPROVED-9805] || Test || Used for testing JPA-RS features.
 +
|}
 +
 +
== NOSQL Component Specific Dependencies  ==
 +
{|{{BMTableStyle}}
 +
|-{{BMTHStyle}}
 +
! Library Name
 +
! Version
 +
! IP Bug
 +
! Dist/Comp/Test
 +
! Notes
 +
|-
 +
| MongoDB Driver || 2.7.3 '''!!! (right now using 2.10)''' || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=6168 APPROVED-6168] || Compile || Required by NOSql
 +
|}
 +
 +
== Transitive Dependencies  ==
 +
{|{{BMTableStyle}}
 +
|-{{BMTHStyle}}
 +
! Library Name
 +
! Version
 +
! IP Bug
 +
! Dist/Comp/Test
 +
! Notes
 +
|-
 +
| JAX-RPC || 1.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=2287 APPROVED-2287] || Transitive || Transitive dependency from javax.ejb
 +
|-
 +
| javax.inject || 1.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=6662 APPROVED-6662] || Transitive || Transitive dependency from cdi-api
 +
|}
 +
 +
== Obsolete Dependencies - to be removed ==
 +
{|{{BMTableStyle}}
 +
|-{{BMTHStyle}}
 +
! Library Name
 +
! Version
 +
! IP Bug
 +
! Dist/Comp/Test
 +
! Notes
 +
|-
 +
| BND || 0.0.351 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=3481 APPROVED-3481] || Compile || Used for OSGi Manifest generation, manipulation.
 +
|-
 +
| StAX <br>(Included in JAXB 2.0) || 1.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1618 APPROVED-1618] || Compile || Optional processing style in MOXy. <br>Always included in JavaEE5 containers. Included in JDK 6 >. <br>Removed in EclipseLink 2.7.
 +
|-
 +
| Java Activation Framework <br>(Included in JAXB 2.0) || 1.1 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1620 APPROVED-1620] || Compile || Required for Web Service attachment handling in MOXy.<br> Always included in JavaEE5 containers. Found in all JDKs > 5.<br> Available from [http://download.eclipse.org/tools/orbit/downloads/drops/R200709171314/bundles/javax.activation_1.1.0.v200706111329.jar Orbit].  <br>Removed in EclipseLink 2.7.
 +
|-
 +
| JPA (EJB 3.0) || 1.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=1616 APPROVED-1616] || Compile || Only required when using JPA. Required in Java SE but always included in Java EE containers.
 +
|-
 +
| Xerces || 2.9.0 || [https://dev.eclipse.org/ipzilla/show_bug.cgi?id=2046 APPROVED-2046] || Compile || Used by Workbench. Workbench obsolete as of now.
 
|}
 
|}
  
 
== Third Party Dependencies ==
 
== Third Party Dependencies ==
  
As per the [http://www.eclipse.org/org/documents/Eclipse_Policy_and_Procedure_for_3rd_Party_Dependencies_Final.pdf Policy and Procedure for 3rd Party Dependencies] the EclipseLink project has the following works-with dependencies.
+
As per the [http://www.eclipse.org/org/documents/Eclipse_Policy_and_Procedure_for_3rd_Party_Dependencies_Final.pdf Policy and Procedure for 3rd Party Dependencies] the EclipseLink project has the following works-with dependencies. EclipseLink's pre-req behavior is as documented in the [[EclipseLink/IPLog | IP Log]] working with standard data source access APIs and compatible implementations.
 +
 
 +
The following dependencies are optional '''works-with''' capabilities available for those users who wish to access advanced features of the Oracle database and therefore have the corresponding libraries available from their database distribution. The functionality that leverages the additional features is isolated within SVN at: /foundation/org.eclipse.persistence.oracle . Both the Eclipse projects and ANT targets provided enable users to build and test EclipseLink without these optional dependencies or if they want to use these they can configure either Eclipse IDE variables or customize ANT properties files to provide the location of their works-with Oracle JDBC libraries.
  
 
{|{{BMTableStyle}}
 
{|{{BMTableStyle}}
Line 51: Line 180:
 
! Notes
 
! Notes
 
|-
 
|-
| [http://www.oracle.com/technology/software/tech/java/sqlj_jdbc/index.html Oracle JDBC] || ojdbc*.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.platform.database.oracle.Oracle8Platform <br> org.eclipse.persistence.platform.database.oracle.Oracle9Platform <br> org.eclipse.persistence.internal.platform.database.oracle.XMLTypeFactory <br> org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter
+
| [http://www.oracle.com/technology/software/tech/java/sqlj_jdbc/index.html Oracle JDBC] || ojdbc*.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.platform.database.oracle.Oracle8Platform <br> org.eclipse.persistence.platform.database.oracle.Oracle9Platform <br> org.eclipse.persistence.platform.database.oracle.Oracle10Platform <br> org.eclipse.persistence.internal.platform.database.oracle.XMLTypeFactory <br> org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter
 
|-
 
|-
 
| [http://www.oracle.com/technology/software/products/spatial/index.html Oracle Spatial Java Class Library]  || sdoapi.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter <br> Note: This version is for use with Oracle 10g Spatial 10.1.0.2, 10.1.0.1, 9iR2, 9iR1, and with JDK 1.4.2 or higher.
 
| [http://www.oracle.com/technology/software/products/spatial/index.html Oracle Spatial Java Class Library]  || sdoapi.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter <br> Note: This version is for use with Oracle 10g Spatial 10.1.0.2, 10.1.0.1, 9iR2, 9iR1, and with JDK 1.4.2 or higher.
Line 58: Line 187:
 
|-
 
|-
 
| [http://www.oracle.com/technology/products/dataint/index.html Oracle AQ] || aqapi.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.internal.eis.adapters.aq.* (5 classes) <br> Note: Seems to only be available from the database distribution.
 
| [http://www.oracle.com/technology/products/dataint/index.html Oracle AQ] || aqapi.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.internal.eis.adapters.aq.* (5 classes) <br> Note: Seems to only be available from the database distribution.
 +
|-
 +
| [http://www.oracle.com/technetwork/database/enterprise-edition/downloads/ucp-112010-099129.html Oracle UCP] || ucp.jar || [http://www.oracle.com/technology/software/htdocs/devlic.html OTN] || org.eclipse.persistence.platform.database.oracle.ucp.* (1 class) <br> Note: Seems to only be available from the database distribution.
 
|-
 
|-
 
|}
 
|}
 +
 +
[[Category:EclipseLink|Dependencies]]

Latest revision as of 02:58, 24 August 2017

The following is a list of Dependencies that EclipseLink requires to compile all components.

Build Tools, Dependencies

Library Name Version IP Bug Dist/Comp/Test Notes
ANT 1.7.0 / 1.8.4 APPROVED-2282
MISSING-????
Compile Used for compilation.
GRADLE 2.3 PENDING-9614 Compile Used for compilation.

Dependencies

Library Name Version IP Bug Dist/Comp/Test Notes
ASM 6.0.0.ALPHA APPROVED-12786 Distributed Internalized into org.eclipse.persistence.internal.libraries.asm. Used for byte-code weaving of persistent classes
ANTLR 3.2 APPROVED-4466 Distributed Internalized into org.eclipse.persistence.internal.libraries.antlr.
Required for parsing JPQL.
JAXB API 2.2 / 2.2.12 APPROVED-8374 Distributed Only required when using JAXB (Not required for native OXM usage). Always included in Java EE containers, and in JDK.
JAXB Core 2.2.11 APPROVED-8984 Distributed Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in Java EE containers.
JAXB XJC 2.2.11 APPROVED-8371 Distributed Only required when using JAXB 2.0 Schema Compiler (Not required for native OXM usage). Always included in JavaEE5 containers.
JavaMail 1.4 APPROVED-1619 Distributed Required for Web Service attachment handling in MOXy.
Always included in Java EE containers.
Service Data Objects (SDO) 2.1.1 APPROVED-2884 Distributed Only required when using SDO functionality.
JSON-P API+RI 1.0.4 APPROVED-8679 Distributed Required by JSON support in MOXy, used for JSON parsing.
Bean Validation API (javax.validation) 1.1.0 APPROVED-8334 Distributed Required by MOXy - used for supporting Bean Validation feature. Reflectively also used in JPA.
JSON-B API ANY PENDING-9615 Distributed Required by JSON-B Implementation.
JTA 1.1 APPROVED-1613 Compile Only required when using JTA. Generally provided by host container.
JMS 1.1 !!! (pulling org.eclipse.net4j.jms.api:jar:3.1.100.v20140218-1709 from somewhere) APPROVED-1614 Compile Only required when using JMS cache coordination. Typically provided by host container.
EJB API 3.1.1 APPROVED-6329 Compile Only required for compilation of MessageDrivenBean code. Included in Java EE containers.
CDI API 1.0 APPROVED-6951 Compile Included in Java EE containers.
JavaEE Connector Architecture (JCA) 1.6 APPROVED-7339 Compile Only required when using EIS data source support through JCA.
JGroups 3.2.8 APPROVED-7143 Compile Only required when using JGroups integration available within org.eclipse.persistence.extensions module. Since 2.6
JAXB Impl 2.2.11 APPROVED-8372 Test Only used for RI compatibility testing. Always included in JavaEE5 containers.
Expression Language API 2.2 APPROVED-8429 Test Required by Hibernate for Bean Validation testing.
Expression Language Implementation 2.2.2 APPROVED-8430 Test Required by Hibernate for Bean Validation testing.
Classmate library 1.0.0 APPROVED-8433 Test Required by Hibernate for Bean Validation testing.
JBoss Logging Framework 3.1.4 APPROVED-8431 Test Required by Hibernate for Bean Validation testing.
Hibernate Bean Validation Implementation all (5.1.0 current) APPROVED-3571 Test Required by Hibernate for Bean Validation testing.
JMockit 1.10 APROVED-8545 Test Used for mocking objects.
Kryo 2.2.1 APROVED-7299 Test Used for fast serialization of objects in JPA. Only loaded by reflection when present and enabled. No compilation or runtime dependency.
JMH Core 0.9.3 APROVED-8546 Test Required by JMH framework for performance testing.
JMH Generator 0.9.3 APROVED-8547 Test Required by JMH framework for performance testing.
Math Commons 3.3 APROVED-8548 Test Required by JMH framework for performance testing.
JOpt Simple 4.6 APROVED-8549 Test Required by JMH framework for performance testing.
OSGi Core 6.0.0 APROVED-9814 Test OSGi testing dependency.
Pax exam all (4.5.0) APROVED-9814 Test OSGi testing dependency.
Pax exam container native all (4.5.0) APROVED-9814 Test OSGi testing dependency.
Pax exam junit4 all (4.5.0) APROVED-9814 Test OSGi testing dependency.
Pax url aether all (2.4.1) APROVED-9814 Test OSGi testing dependency.
Pax exam link mvn all (4.5.0) APROVED-9814 Test OSGi testing dependency.
Apache Felix all (5.0.0) APROVED-9814 Test OSGi testing dependency.
javax.el all (3.0.0) APROVED-9814 Test OSGi testing dependency.
log4j all (2.3) APROVED-9814 Test OSGi testing dependency.

DBWS Component Specific Dependencies

Library Name Version IP Bug Dist/Comp/Test Notes
WSDL4J 1.6.2 APPROVED-1701 Distributed Required by DBWS
Servlet API 2.4.0 / !!! (pulling 3.0.0 somewhere for some reason) APPROVED-2505
MISSING-????
Compile Required by DBWS
JAX-RS API 2.0.1 APPROVED-9752 Compile Used for compilation of JPA-RS features.
Jersey Client 2.14 APPROVED-9805 Test Used for testing JPA-RS features.

NOSQL Component Specific Dependencies

Library Name Version IP Bug Dist/Comp/Test Notes
MongoDB Driver 2.7.3 !!! (right now using 2.10) APPROVED-6168 Compile Required by NOSql

Transitive Dependencies

Library Name Version IP Bug Dist/Comp/Test Notes
JAX-RPC 1.1 APPROVED-2287 Transitive Transitive dependency from javax.ejb
javax.inject 1.0 APPROVED-6662 Transitive Transitive dependency from cdi-api

Obsolete Dependencies - to be removed

Library Name Version IP Bug Dist/Comp/Test Notes
BND 0.0.351 APPROVED-3481 Compile Used for OSGi Manifest generation, manipulation.
StAX
(Included in JAXB 2.0)
1.0 APPROVED-1618 Compile Optional processing style in MOXy.
Always included in JavaEE5 containers. Included in JDK 6 >.
Removed in EclipseLink 2.7.
Java Activation Framework
(Included in JAXB 2.0)
1.1 APPROVED-1620 Compile Required for Web Service attachment handling in MOXy.
Always included in JavaEE5 containers. Found in all JDKs > 5.
Available from Orbit.
Removed in EclipseLink 2.7.
JPA (EJB 3.0) 1.0 APPROVED-1616 Compile Only required when using JPA. Required in Java SE but always included in Java EE containers.
Xerces 2.9.0 APPROVED-2046 Compile Used by Workbench. Workbench obsolete as of now.

Third Party Dependencies

As per the Policy and Procedure for 3rd Party Dependencies the EclipseLink project has the following works-with dependencies. EclipseLink's pre-req behavior is as documented in the IP Log working with standard data source access APIs and compatible implementations.

The following dependencies are optional works-with capabilities available for those users who wish to access advanced features of the Oracle database and therefore have the corresponding libraries available from their database distribution. The functionality that leverages the additional features is isolated within SVN at: /foundation/org.eclipse.persistence.oracle . Both the Eclipse projects and ANT targets provided enable users to build and test EclipseLink without these optional dependencies or if they want to use these they can configure either Eclipse IDE variables or customize ANT properties files to provide the location of their works-with Oracle JDBC libraries.

Library Jars License Notes
Oracle JDBC ojdbc*.jar OTN org.eclipse.persistence.platform.database.oracle.Oracle8Platform
org.eclipse.persistence.platform.database.oracle.Oracle9Platform
org.eclipse.persistence.platform.database.oracle.Oracle10Platform
org.eclipse.persistence.internal.platform.database.oracle.XMLTypeFactory
org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter
Oracle Spatial Java Class Library sdoapi.jar OTN org.eclipse.persistence.platform.database.oracle.converters.JGeometryConverter
Note: This version is for use with Oracle 10g Spatial 10.1.0.2, 10.1.0.1, 9iR2, 9iR1, and with JDK 1.4.2 or higher.
Oracle XDK xml.jar
xmlparserv2.jar
xdb.jar
OTN XMLTypeBindCallCustomParameter & XMLTypeFactoryImpl (org.eclipse.persistence.internal.platform.database.oracle.xdb)
DirectToXMLTypeMapping(org.eclipse.persistence.mappings.xdb)
org.eclipse.persistence.platform.xml.xdk.* (5 classes)
Oracle AQ aqapi.jar OTN org.eclipse.persistence.internal.eis.adapters.aq.* (5 classes)
Note: Seems to only be available from the database distribution.
Oracle UCP ucp.jar OTN org.eclipse.persistence.platform.database.oracle.ucp.* (1 class)
Note: Seems to only be available from the database distribution.